version: 2
jobs:
  build:
    docker:
      - image: fenicsproject/performance-tests:latest
    working_directory: ~/working
    steps:
      - checkout
      - run:
          name: Compile UFL files
          command: |
            cd src/
            ffc -l dolfin Elasticity.ufl
            ffc -l dolfin Poisson.ufl
      - run:
          name: Build test program
          command: |
            cd src/
            cmake .
            make
      - run:
          name: Run Poisson test (BoomerAMG, weak)
          command: |
            cd src/
            mpirun -np 3 ./dolfin-scaling-test \
            --problem_type poisson \
            --scaling_type weak \
            --ndofs 50000 \
            --petsc.log_view \
            --petsc.ksp_view \
            --petsc.ksp_type cg \
            --petsc.ksp_rtol 1.0e-8 \
            --petsc.pc_type hypre \
            --petsc.pc_hypre_type boomeramg \
            --petsc.pc_hypre_boomeramg_strong_threshold 0.5 \
            --petsc.options_left
      - run:
          name: Run Poisson test (BoomerAMG, strong)
          command: |
            cd src/
            mpirun -np 3 ./dolfin-scaling-test \
            --problem_type poisson \
            --scaling_type strong \
            --ndofs 1000000 \
            --petsc.log_view \
            --petsc.ksp_view \
            --petsc.ksp_type cg \
            --petsc.ksp_rtol 1.0e-8 \
            --petsc.pc_type hypre \
            --petsc.pc_hypre_type boomeramg \
            --petsc.pc_hypre_boomeramg_strong_threshold 0.5 \
            --petsc.options_left
      - run:
          name: Run elasticity test (GAMG, weak)
          command: |
            cd src/
            mpirun -np 3 ./dolfin-scaling-test \
            --problem_type elasticity \
            --scaling_type weak \
            --ndofs 100000 \
            --petsc.log_view \
            --petsc.ksp_view \
            --petsc.ksp_type cg \
            --petsc.ksp_rtol 1.0e-8 \
            --petsc.pc_type gamg \
            --petsc.pc_gamg_coarse_eq_limit 1000 \
            --petsc.mg_levels_ksp_type chebyshev \
            --petsc.mg_levels_pc_type jacobi \
            --petsc.mg_levels_esteig_ksp_type cg \
            --petsc.matptap_via scalable \
            --petsc.options_left
      - run:
          name: Run elasticity test (GAMG, strong)
          command: |
            cd src/
            mpirun -np 3 ./dolfin-scaling-test \
            --problem_type elasticity \
            --scaling_type strong \
            --ndofs 1000000 \
            --petsc.log_view \
            --petsc.ksp_view \
            --petsc.ksp_type cg \
            --petsc.ksp_rtol 1.0e-8 \
            --petsc.pc_type gamg \
            --petsc.pc_gamg_coarse_eq_limit 1000 \
            --petsc.mg_levels_ksp_type chebyshev \
            --petsc.mg_levels_pc_type jacobi \
            --petsc.mg_levels_esteig_ksp_type cg \
            --petsc.matptap_via scalable \
            --petsc.options_left
